3 # Common routines for all tests
6 # assert that argument is not empty and is an existing path (file or directory)
12 if [ -z "$path" ]; then
13 echo "ASSERTION FAIL: $path is not valid"
17 if [ -f "$path" -o -d "$path" -o -b "$path" ]; then
20 echo "ASSERTION FAIL: $path is not valid"
24 # $1: this string gets matched to files, absolute or relative path, or a
25 # systemwide command available via $PATH
31 if [ -z "$msg" ]; then
35 if [ -f "$msg" -o -d "$msg" -o -b "$msg" ]; then
39 if [ -f "$msg" ]; then
47 echo "$*" | tee -a "$RESULTS"
51 # log a message to the results file
54 echo "$*" | tee -a "$RESULTS"
69 echo "DUMP args for ${FUNCNAME[1]}:"
70 while [ $# -gt 0 ]; do
77 # read arguments, look if we're calling btrfs and if there's a known
78 # subcommand, return argument index to insert, taking root helper into
79 # consideration, returns 2 for unknown subcommand
82 if [ "$1" = 'root_helper' ]; then
83 if [[ $2 =~ /btrfs$ ]]; then
88 if [[ $1 =~ /btrfs$ ]]; then
96 # return command-specific arguments if enabled
99 if [ "$TEST_ENABLE_OVERRIDE" = 'true' ]; then
100 # if defined via common.local, use it, otherwise pass make
102 if [ "$(type -t _skip_spec)" = 'function' ]; then
103 if _skip_spec "$@"; then
108 check) echo -n "$TEST_ARGS_CHECK" ;;
113 # Argument passing magic:
114 # the command passed to run_* helpers is inspected, if there's 'btrfs command'
115 # found and there are defined additional arguments, they're inserted just after
116 # the command name, ie. any arguments in the test could override them.
118 # The root helper is recognized. Unrecognized subcommands or external tools
127 ins=$(_get_spec_ins "$@")
129 cmd=$(eval echo "\${$spec}")
130 spec=$(_cmd_spec "${@:$spec}")
131 set -- "${@:1:$(($ins-1))}" $spec "${@: $ins}"
132 echo "############### $@" >> "$RESULTS" 2>&1
133 if [[ $TEST_LOG =~ tty ]]; then echo "CMD: $@" > /dev/tty; fi
134 if [ "$1" = 'root_helper' ]; then
135 "$@" >> "$RESULTS" 2>&1 || _fail "failed: $@"
137 $INSTRUMENT "$@" >> "$RESULTS" 2>&1 || _fail "failed: $@"
141 # same as run_check but the stderr+stdout output is duplicated on stdout and
142 # can be processed further
149 ins=$(_get_spec_ins "$@")
151 cmd=$(eval echo "\${$spec}")
152 spec=$(_cmd_spec "${@:$spec}")
153 set -- "${@:1:$(($ins-1))}" $spec "${@: $ins}"
154 echo "############### $@" >> "$RESULTS" 2>&1
155 if [[ $TEST_LOG =~ tty ]]; then echo "CMD(stdout): $@" > /dev/tty; fi
156 if [ "$1" = 'root_helper' ]; then
157 "$@" 2>&1 | tee -a "$RESULTS" || _fail "failed: $@"
159 $INSTRUMENT "$@" 2>&1 | tee -a "$RESULTS" || _fail "failed: $@"
163 # same as run_check but does not fail the test if it's handled gracefully by
164 # the tool, unexpected failure like segfault or abor will exit forcibly
173 ins=$(_get_spec_ins "$@")
175 cmd=$(eval echo "\${$spec}")
176 spec=$(_cmd_spec "${@:$spec}")
177 set -- "${@:1:$(($ins-1))}" $spec "${@: $ins}"
178 echo "############### $@" >> "$RESULTS" 2>&1
179 if [[ $TEST_LOG =~ tty ]]; then echo "CMD(mayfail): $@" > /dev/tty; fi
180 if [ "$1" = 'root_helper' ]; then
181 "$@" >> "$RESULTS" 2>&1
183 $INSTRUMENT "$@" >> "$RESULTS" 2>&1
186 if [ $ret != 0 ]; then
187 echo "failed (ignored, ret=$ret): $@" >> "$RESULTS"
188 if [ $ret == 139 ]; then
189 _fail "mayfail: returned code 139 (SEGFAULT), not ignored"
190 elif [ $ret == 134 ]; then
191 _fail "mayfail: returned code 134 (SIGABRT), not ignored"
197 # first argument is error message to print if it fails, otherwise
198 # same as run_check but expects the command to fail, output is logged
209 if _is_file_or_command "$msg"; then
210 echo "ASSERTION FAIL: 1st argument of run_mustfail must be a message"
214 ins=$(_get_spec_ins "$@")
216 cmd=$(eval echo "\${$spec}")
217 spec=$(_cmd_spec "${@:$spec}")
218 set -- "${@:1:$(($ins-1))}" $spec "${@: $ins}"
219 echo "############### $@" >> "$RESULTS" 2>&1
220 if [[ $TEST_LOG =~ tty ]]; then echo "CMD(mustfail): $@" > /dev/tty; fi
221 if [ "$1" = 'root_helper' ]; then
222 "$@" >> "$RESULTS" 2>&1
224 $INSTRUMENT "$@" >> "$RESULTS" 2>&1
227 echo "failed (expected): $@" >> "$RESULTS"
230 echo "succeeded (unexpected!): $@" >> "$RESULTS"
231 _fail "unexpected success: $msg"
238 if ! [ -f "$TOP/$1" ]; then
239 _fail "Failed prerequisites: $1";
243 check_global_prereq()
245 which $1 &> /dev/null
246 if [ $? -ne 0 ]; then
247 _fail "Failed system wide prerequisities: $1";
256 echo "testing image $(basename $image)" >> "$RESULTS"
257 "$TOP/btrfs" check "$image" >> "$RESULTS" 2>&1
258 [ $? -eq 0 ] && _fail "btrfs check should have detected corruption"
260 run_check "$TOP/btrfs" check --repair "$image"
261 run_check "$TOP/btrfs" check "$image"
264 # Extract a usable image from packed formats
265 # - raw btrfs filesystem images, suffix .raw
266 # - dtto compressed by XZ, suffix .raw.xz
267 # - meta-dump images with suffix .img
268 # - dtto compressed by XZ, suffix .img.xz
269 # - compressed send stream, .stream.xz
278 rm -f "$image.restored"
281 xz --decompress --keep "$image" || \
282 _fail "failed to decompress image $image" >&2
284 rm -f "$image.restored"
288 cp --sparse=auto "$image" "$image.restored"
291 xz --decompress --keep "$image" || \
292 _fail "failed to decompress image $image" >&2
294 mv "$image" "$image.restored"
297 xz --decompress --keep "$image" || \
298 _fail "failed to decompress file $image" >&2
300 mv "$image" "$image.restored"
304 if ! [ -f "$image.restored" ]; then
305 echo "restoring image $(basename $image)" >> "$RESULTS"
306 "$TOP/btrfs-image" -r "$image" "$image.restored" \
308 || _fail "failed to restore image $image" >&2
311 [ -f "$cleanme" ] && rm -f "$cleanme"
313 echo "$image.restored"
316 # Process all image dumps in a given directory
323 if [ -z "$dir" ]; then
327 for image in $(find "$dir" \( -iname '*.img' -o \
328 -iname '*.img.xz' -o \
330 -iname '*.raw.xz' \) | sort)
332 extracted=$(extract_image "$image")
333 check_image "$extracted"
338 # some tests need to mount the recovered image and do verifications call
339 # 'setup_root_helper' and then check for have_root_helper == 1 if the test
340 # needs to fail otherwise; using sudo by default for now
342 NEED_SUDO_VALIDATE=unknown
344 export NEED_SUDO_VALIDATE
347 if [ $UID -eq 0 ]; then
350 if [ "$NEED_SUDO_VALIDATE" = 'yes' ]; then
351 sudo -v -n &>/dev/null || \
352 _not_run "Need to validate sudo credentials"
354 elif [ "$NEED_SUDO_VALIDATE" = 'no' ]; then
355 sudo -n /bin/true &> /dev/null || \
356 _not_run "Need to validate sudo user settings"
360 _not_run "Need to validate root privileges"
367 if [ $UID -eq 0 -o -n "$SUDO_HELPER" ]; then
371 # Test for old sudo or special settings, which make sudo -v fail even
372 # if user setting is NOPASSWD
373 sudo -n /bin/true &>/dev/null && NEED_SUDO_VALIDATE=no
375 # Newer sudo or default sudo setting
376 sudo -v -n &>/dev/null && NEED_SUDO_VALIDATE=yes
378 if [ "$NEED_SUDO_VALIDATE" = 'unknown' ]; then
379 _not_run "Need to validate root privileges"
381 SUDO_HELPER=root_helper
389 [[ "$TEST_DEV" ]] && return
390 [[ "$size" ]] || size='2G'
392 echo "\$TEST_DEV not given, use $TOP/test/test.img as fallback" >> \
394 TEST_DEV="$TOP/tests/test.img"
396 truncate -s "$size" "$TEST_DEV" || _not_run "create file for loop device failed"
399 run_check_mount_test_dev()
404 if [[ -b "$TEST_DEV" ]]; then
406 elif [[ -f "$TEST_DEV" ]]; then
409 _fail "Invalid \$TEST_DEV: $TEST_DEV"
412 [[ -d "$TEST_MNT" ]] || {
413 _fail "Invalid \$TEST_MNT: $TEST_MNT"
416 run_check $SUDO_HELPER mount -t btrfs $loop_opt "$@" "$TEST_DEV" "$TEST_MNT"
419 run_check_umount_test_dev()
422 run_check $SUDO_HELPER umount "$@" "$TEST_DEV"
425 check_kernel_support()
427 if ! grep -iq 'btrfs' /proc/filesystems; then
428 echo "WARNING: btrfs filesystem not listed in /proc/filesystems, some tests might fail"
434 # how many files to create.
440 dirpath=$TEST_MNT/$dataset_type
441 run_check $SUDO_HELPER mkdir -p "$dirpath"
443 case "$dataset_type" in
445 for num in $(seq 1 "$DATASET_SIZE"); do
446 run_check $SUDO_HELPER dd if=/dev/urandom of="$dirpath/$dataset_type.$num" bs=10K \
447 count=1 >/dev/null 2>&1
452 for num in $(seq 1 "$DATASET_SIZE"); do
453 run_check $SUDO_HELPER touch "$dirpath/$dataset_type.$num"
454 run_check $SUDO_HELPER ln "$dirpath/$dataset_type.$num" "$dirpath/hlink.$num"
459 for num in $(seq 1 "$DATASET_SIZE"); do
460 run_check $SUDO_HELPER touch "$dirpath/$dataset_type.$num"
461 run_check cd "$dirpath" && \
462 $SUDO_HELPER ln -s "$dataset_type.$num" "$dirpath/slink.$num" && \
468 for num in $(seq 1 "$DATASET_SIZE"); do
469 run_check $SUDO_HELPER ln -s "$dirpath/$dataset_type.$num" "$dirpath/blink.$num"
474 for modes in 777 775 755 750 700 666 664 644 640 600 444 440 400 000 \
475 1777 1775 1755 1750 1700 1666 1664 1644 1640 1600 1444 1440 1400 1000 \
476 2777 2775 2755 2750 2700 2666 2664 2644 2640 2600 2444 2440 2400 2000 \
477 4777 4775 4755 4750 4700 4666 4664 4644 4640 4600 4444 4440 4400 4000; do
478 run_check $SUDO_HELPER touch "$dirpath/$dataset_type.$modes"
479 run_check $SUDO_HELPER chmod "$modes" "$dirpath/$dataset_type.$modes"
484 for num in $(seq 1 "$DATASET_SIZE"); do
485 run_check $SUDO_HELPER dd if=/dev/urandom of="$dirpath/$dataset_type.$num" bs=10K \
486 count=1 >/dev/null 2>&1
487 run_check $SUDO_HELPER truncate -s 500K "$dirpath/$dataset_type.$num"
488 run_check $SUDO_HELPER dd if=/dev/urandom of="$dirpath/$dataset_type.$num" bs=10K \
489 oflag=append conv=notrunc count=1 >/dev/null 2>&1
490 run_check $SUDO_HELPER truncate -s 800K "$dirpath/$dataset_type.$num"
495 for num in $(seq 1 "$DATASET_SIZE"); do
496 run_check $SUDO_HELPER touch "$dirpath/$dataset_type.$num"
497 run_check $SUDO_HELPER setfacl -m "u:root:x" "$dirpath/$dataset_type.$num"
498 run_check $SUDO_HELPER setfattr -n user.foo -v "bar$num" "$dirpath/$dataset_type.$num"
503 for num in $(seq 1 "$DATASET_SIZE"); do
504 run_check $SUDO_HELPER mkfifo "$dirpath/$dataset_type.$num"
509 long_filename=`date +%s | sha256sum | cut -f1 -d'-'`
510 run_check $SUDO_HELPER touch "$dirpath/$long_filename"
511 for num in $(seq 1 "$DATASET_SIZE"); do
512 run_check $SUDO_HELPER ln -s "$dirpath/$long_filename" "$dirpath/slow_slink.$num"
516 run_check $SUDO_HELPER dd if=/dev/urandom bs=32M count=1 \
517 of="$dirpath/$dataset_type" >/dev/null 2>&1
522 # prepare environment for loop devices, set up the following variables
523 # - nloopdevs -- number of desired devices
524 # - loopdevs -- array containing paths to all devices (after prepare is called)
525 # - loopdev_prefix -- file backed images starting with this string, 'img' by default
527 # $1: number of loop devices to be set up
531 _fail "setup_loopdevs needs a number"
539 # create all loop devices from a given loopdev environment
542 for i in `seq $nloopdevs`; do
543 touch $loopdev_prefix$i
544 chmod a+rw $loopdev_prefix$i
545 truncate -s0 $loopdev_prefix$i
546 truncate -s2g $loopdev_prefix$i
547 loopdevs[$i]=`run_check_stdout $SUDO_HELPER losetup --find --show $loopdev_prefix$i`
551 # detach loop devices and reset their size to 0, does not delete the files
554 for dev in ${loopdevs[@]}; do
555 run_check $SUDO_HELPER losetup -d $dev
557 for i in `seq $nloopdevs`; do
558 truncate -s0 $loopdev_prefix$i
560 run_check $SUDO_HELPER losetup --all
565 TEST_MNT="${TEST_MNT:-$TOP/tests/mnt}"
567 mkdir -p "$TEST_MNT" || { echo "Failed mkdir -p $TEST_MNT"; exit 1; }
569 source $TOP/tests/common.local
571 if [ "$TEST_ENABLE_OVERRIDE" = 'true' -a -n "$RESULTS" ]; then
572 echo "INCLUDE common.local" >> "$RESULTS"
573 echo " check: $TEST_ARGS_CHECK" >> "$RESULTS"